
/**
 * Title:        MenuApplet2L<p>
 * Description:  <p>
 * Copyright:    Copyright (c) Aldo Giove 2002<p>
 * Company:      <p>
 * @author Aldo Giove (a.giove@mclink.it)
 * @version 1.32
 */

package menuapplet2l;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.net.URL;
import java.util.Vector;

public class MenuApplet2L extends Applet implements ActionListener {

  boolean isStandalone = false;
  Color bkg,
        bkg2;
  int ndxSceltaAperta = -1;
  // Vettore dei dati di TUTTE le scelte
  Vector dScelte = new Vector();
  // Vettore dei dati delle sole scelte di primo livello
  Vector dScelte1 = new Vector();
  Vector scelte = new Vector();
  String defaultFrame;
  int nImmaginiInCaricamento = 0;
  int defaultChoiceHeight = 0;
  boolean scrollingAllowed = false;
  boolean debugActive = false;

  Font defaultFont;

  GridBagLayout layout = new GridBagLayout();
  Panel mainPanel = new Panel(layout);
  Container scrollPane; // Puo' essere o non essere scrolling

  // ------------------------------------------------------

  /** Prints out to the console some diagnostic information */
  public void debugOut(String msg)
  {
    if (debugActive)
      System.out.println(msg);
  }

  // ------------------------------------------------------

  public String getParameter(String key, String def)
  {
    return isStandalone ? System.getProperty(key, def) :
      (getParameter(key) != null ? getParameter(key) : def);
  }

  // ------------------------------------------------------

  public MenuApplet2L() {
//    mainPanel.setBackground(new Color(192, 192, 192));
    setLayout(new GridLayout(1, 1));
    debugOut("MenuApplet2L creata.");
  }

  // ------------------------------------------------------

  // Restituisce una "new" scelta oppure NULL
  public DatiMenuAppletScelta leggiParametriScelta(String chiave, int id)
  {
    Dimension dApplet = getSize();

    DatiMenuAppletScelta d = null;
    String scelta = this.getParameter(chiave, "");

    if (scelta.length() > 0)
    {
      String url = getParameter(chiave+"-URL", null),
             frame = getParameter(chiave+"-FRAME", defaultFrame),
             im = getParameter(chiave+"-IMG", null),
             im2 = getParameter(chiave+"-IMG2", null),
             im3 = getParameter(chiave+"-IMG3", null),
             fnt = getParameter(chiave+"-FONT", null);
      int choiceHeight = defaultChoiceHeight;
      try {
        String s = getParameter(chiave+"-HEIGHT", null);
        if (s != null)
        {
          int h = Integer.parseInt(s);
          if (h > 0)
            choiceHeight = h;
        }
      }
      catch (Exception e) {
        e.printStackTrace();
      }

      // Verifica se la URL e' assoluta o relativa
      if (url != null && (url.indexOf(":") < 0)) // URL relativa
        url = getCodeBase() + url;

      Image img = null,
            img2 = null,
            img3 = null;

      if (im != null && im.length() > 0)
      {
        try {
          img = getImage(getCodeBase(), im);
          img2 = getImage(getCodeBase(), im2);
          img3 = getImage(getCodeBase(), im3);
        }
        catch(Exception e) {
          e.printStackTrace();
        }
      }

      Font f = creaFont(fnt);
      if (f == null)
        f = defaultFont;

      d = new DatiMenuAppletScelta(id, scelta, url, frame, img, img2, img3,
                                   dApplet.width, choiceHeight, f);
    }

    return d;
  }

  // ------------------------------------------------------

  public Color parseColor(String s)
  {
    Color color = null;
    try {
      int r = Integer.parseInt(s.substring(0, 2), 16),
          g = Integer.parseInt(s.substring(2, 4), 16),
          b = Integer.parseInt(s.substring(4, 6), 16);
      color = new Color(r, g, b);
    }
    catch (Exception e) {
      e.printStackTrace();
    }
    return color;
  }

  // ------------------------------------------------------

  public Font creaFont(String s)
  {
    Font fnt = null;
    if (s != null && s.length() > 0)
    {
      String face,
             attr,
             size;
      int p = s.indexOf(",");
      if (p >= 0)
      {
        face = s.substring(0, p);
        s = s.substring(p+1);

        p = s.indexOf(",");
        if (p >= 0)
        {
          attr = s.substring(0, p);
          s = s.substring(p+1);

          int attrib = Font.PLAIN;
          if (attr.indexOf("BOLD") >= 0)
            attrib |= Font.BOLD;
          if (attr.indexOf("ITALIC") >= 0)
            attrib |= Font.ITALIC;

          try
          {
            int h = Integer.parseInt(s);

            if (h > 0)
              fnt = new Font(face, attrib, h);
          }
          catch (Exception e)
          {
            e.printStackTrace();
          }
        }
      }
    }
    return fnt;
  }

  // ------------------------------------------------------

  public void init()
  {
    debugOut("MenuApplet2L: init...");

    Dimension dApplet = getSize();

    // Legge gli argomenti ed alloca le relative scelte

    defaultFrame = getParameter("DefaultFrame", "_self");

    String sScrollingAllowed = getParameter("ScrollingAllowed", "FALSE");
    if (sScrollingAllowed.equalsIgnoreCase("TRUE"))
      scrollingAllowed = true;

    String sDebugActive = getParameter("DebugActive", "FALSE");
    if (sDebugActive.equalsIgnoreCase("TRUE"))
      debugActive = true;

    try {
      String s = getParameter("DefaultChoiceHeight", "25");
      int h = Integer.parseInt(s);
      if (h > 0)
        defaultChoiceHeight = h;
    }
    catch (Exception e) {
      e.printStackTrace();
    }

    Color coloreTesto = parseColor(getParameter("TextColor", "000000")),
          coloreTesto2 = coloreTesto,
          coloreTestoH = new Color(0, 0, 255),
          coloreTestoP = new Color(255, 0, 0);
    String c2 = getParameter("TextColorSubMenu", "");
    if (c2.length() > 0)
      coloreTesto2 = parseColor(c2);
    c2 = getParameter("TextColorHighlight", "");
    if (c2.length() > 0)
      coloreTestoH = parseColor(c2);
    c2 = getParameter("TextColorPressed", "");
    if (c2.length() > 0)
      coloreTestoP = parseColor(c2);

    String defFnt = getParameter("DefaultFont", "");
    if (defFnt.length() > 0)
      defaultFont = creaFont(defFnt);
    if (defaultFont == null)
      defaultFont = new Font("SansSerif", Font.BOLD, 12);

    bkg = parseColor(getParameter("Background", "FFFFFF"));
    bkg2 = parseColor(getParameter("BackgroundSubMenu", "FFFFFF"));
    setBackground(bkg);

    // Lettura scelte di primo livello
    boolean ancoraScelte = true;
    int ndxScelte1 = 0;
    do
    {
      String s = "Choice" + ndxScelte1;

      int id = dScelte.size();
      DatiMenuAppletScelta d = leggiParametriScelta(s, id);

      if (d != null)
      {
        ndxScelte1++;
        dScelte1.addElement(d);
        dScelte.addElement(d);
        // d.id *DEVE* corrispondere a dScelte.indexOf(d);

        MenuAppletScelta ms = new MenuAppletScelta(d);
        ms.assegnaColoreTesto(coloreTesto);
        ms.assegnaColoreTestoHighlight(coloreTestoH);
        ms.assegnaColoreTestoPremuto(coloreTestoP);
        scelte.addElement(ms);
        // Informa il "pulsante" che quest'applet vuole ascoltare i suoi msg
        ms.addActionListener(this);

        // Lettura eventuali scelte di secondo livello
        boolean ancoraSottoScelte = true;
        int ndxSottoScelte = 0;
        do
        {
          String ss = s + "-" + ndxSottoScelte;
          id = dScelte.size();
          DatiMenuAppletScelta ds = leggiParametriScelta(ss, id);
          if (ds != null)
          {
            ndxSottoScelte++;
            ds.assegnaLarghezza(ds.qualeLarghezza()-20);
            dScelte.addElement(ds);
            d.aggiungiSottoScelta(ds);

            MenuAppletScelta mss = new MenuAppletScelta(ds);
            mss.assegnaColoreTesto(coloreTesto2);
            mss.assegnaColoreTestoHighlight(coloreTestoH);
            mss.assegnaColoreTestoPremuto(coloreTestoP);
            scelte.addElement(mss);
            // Informa il "pulsante" che quest'applet vuole ascoltare i suoi msg
            mss.addActionListener(this);
          }
          else
            ancoraSottoScelte = false;
        } while (ancoraSottoScelte);
      }
      else
        ancoraScelte = false;
    } while (ancoraScelte);

    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
    debugOut("MenuApplet2L: init effettuato.");
  }

  // ------------------------------------------------------

  private void jbInit() {
    // Creare il pannello che contiene "mainPanel"
    if (scrollingAllowed)
      scrollPane = new MyScrollPane();
    else
      scrollPane = new Panel();
    add(scrollPane);

    mainPanel.setSize(getSize());
    scrollPane.add(mainPanel);
    scrollPane.validate();

    setBackground(bkg);
    ridisponiPulsanti();
  }

  // ------------------------------------------------------

  public void ridisponiPulsanti()
  {
    debugOut("MenuApplet2L: ridisponiPulsanti()...");

    Panel p = mainPanel;
    p.setVisible(false);
    p.removeAll();
    int quanti = dScelte1.size();
    int nSottoScelte = 0;
    int nRiga = 0;
    boolean secondoLivello = false;
    for (int n = 0; n < quanti; n++, nRiga++)
    {
      DatiMenuAppletScelta d = (DatiMenuAppletScelta)dScelte1.elementAt(n);
      int id = d.qualeId();
      MenuAppletScelta s = (MenuAppletScelta)scelte.elementAt(id);
      p.add(s, new GBConstraints(0, nRiga, 3, 1, 1.0, 0.0));

      if (n == ndxSceltaAperta)
      {
        secondoLivello = true;
        nRiga++;
        // Mostra tutte le sotto-scelte di questa
        nSottoScelte = d.quanteSottoScelte();

        // Crea un elemento "spaziatore" a sx
        Label l = new Label(" ");
//        l.setBackground(Color.yellow);
        p.add(l, new GBConstraints(0, nRiga, 1, nSottoScelte, 0.0, 0.0));

        for (int ns = 0; ns < nSottoScelte; ns++, nRiga++)
        {
          DatiMenuAppletScelta ds = d.qualeSottoScelta(ns);
          int ids = ds.qualeId();
          MenuAppletScelta ms = (MenuAppletScelta)scelte.elementAt(ids);
          p.add(ms, new GBConstraints(1, nRiga, 1, 1, 1.0, 0.0));
        }
      }
    }

    // Crea un elemento "spaziatore" in basso
    Label l = new Label(" ");
//    l.setBackground(Color.blue);
    p.add(l, new GBConstraints(0, nRiga, 3, 1, 1.0, 1.0));

    p.setVisible(true);
    validate();

    // Trick - alcuni componenti talvolta non sono ridisegnati
/*
    Component[] c1 = p.getComponents();
    for (int j = 0; j < c1.length; j++)
      c1[j].repaint();
*/
    debugOut("MenuApplet2L: ridisponiPulsanti() effettuato.");
  }

  // ------------------------------------------------------

  public void actionPerformed(ActionEvent ae)
  {
    // Cercare i dati della scelta relativa al pulsante cliccato
    int id = ae.getID();
    if (id >= 0)
    {
      // Click!
      try {
        DatiMenuAppletScelta d = (DatiMenuAppletScelta)dScelte.elementAt(id);
        if (d.qualeUrl() != null)
        {
          URL url = new URL(d.qualeUrl());
          String frame = d.qualeFrame();
          getAppletContext().showDocument(url, frame);
        }

        if (d.quanteSottoScelte() > 0)
        {
          if (ndxSceltaAperta == dScelte1.indexOf(d))
            ndxSceltaAperta = -1;
          else
            ndxSceltaAperta = dScelte1.indexOf(d);
          ridisponiPulsanti();
        }
      }
      catch(Exception e) {
        e.printStackTrace();
      }
    }
    else
      getAppletContext().showStatus(ae.getActionCommand()); // Hover
  }

  // ------------------------------------------------------

  public boolean imageUpdate(Image img, int infoflags, int x, int y, int width, int height)
  {
    boolean result = super.imageUpdate(img, infoflags, x, y, width, height);
    if ((infoflags & ALLBITS) == ALLBITS) // Un'altra immagine completata
    {
      nImmaginiInCaricamento--;
//      if (nImmaginiInCaricamento <= 0)
//        getAppletContext().showStatus("");
      debugOut("Finished loading an image.");
    }
    return result;
  }

  // ------------------------------------------------------

  public void precaricaImmagine(Image img)
  {
    if (img != null)
    {
      boolean ok = prepareImage(img, this);
      if (!ok)
      {
        nImmaginiInCaricamento++;
//        getAppletContext().showStatus("Images loading...");
        String s = "";
        s = "Image loading: " + s + "...";
        debugOut(s);
      }
    }
  }

  // ------------------------------------------------------

  public void start()
  {
    // Fa in modo da pre-caricare le immagini, ora
    for (int i = 0; i < dScelte.size(); i++)
    {
      DatiMenuAppletScelta d = (DatiMenuAppletScelta)dScelte.elementAt(i);
      Image img = d.qualeImg();
      Image img2 = d.qualeImg2();
      Image img3 = d.qualeImg3();

      precaricaImmagine(img);
      precaricaImmagine(img2);
      precaricaImmagine(img3);
    }
  }

  // ------------------------------------------------------

  public void stop() {
  }

  // ------------------------------------------------------

  public void destroy() {
  }

  // ------------------------------------------------------

  public String getAppletInfo() {
    return "MenuApplet2L v. 1.2 (c) 2002 by Aldo Giove (a.giove@mclink.it)";
  }

  // ------------------------------------------------------

  //Get parameter info
  public String[][] getParameterInfo() {
    String[][] pinfo =
      {
      {"ScrollingAllowed", "Boolean", "TRUE makes the menu scrolling possible (default FALSE)"},
      {"DefaultChoiceHeight", "Integer", "Default height of every menu choice (default: 25)"},
      {"DefaultFont", "String", "Default face, attributes, size of all choices font (default: 'SansSerif,BOLD,12')"},
      {"DefaultFrame", "String", "Default frame to open links in (may be overridden by 'ChoiceN-FRAME' parameters)"},
      {"TextColor", "RRGGBB (hex)", "RGB color of text (example: 000000=black, 0000FF=blue) (default=000000"},
      {"TextColorSubMenu", "RRGGBB (hex)", "RGB color of sub-menu text (example: 000000=black, 0000FF=blue) (default=000000"},
      {"TextColorHighlight", "RRGGBB (hex)", "RGB color of text while it is under the mouse pointer (example: 000000=black, 0000FF=blue) (default=0000FF"},
      {"TextColorPressed", "RRGGBB (hex)", "RGB color of text while it is pushed by the mouse pointer (example: 000000=black, 0000FF=blue) (default=FF0000"},
      {"Background", "RRGGBB (hex)", "RGB color of applet background (example: 000000=black, 0000FF=blue) (default=FFFFFF"},
      {"BackgroundSubMenu", "RRGGBB (hex)", "RGB color of applet sub-menu background (example: 000000=black, 0000FF=blue) (default=FFFFFF"},
      {"Choice0", "String", "First menu choice ('-' = no text)"},
      {"Choice1", "String", "Second menu choice ('-' = no text)"},
      {"ChoiceN", "String", "N-th menu choice ('-' = no text)"},
      {"ChoiceN-URL", "String", "URL to be opened when ChoiceN is clicked (optional)"},
      {"ChoiceN-FRAME", "String", "Destination frame to open ChoiceN URL (optional)"},
      {"ChoiceN-IMG", "String", "URL of image to be shown to the left of ChoiceN; if ChoiceN='-', only the image will be shown (optional)"},
      {"ChoiceN-IMG2", "String", "URL of image to be shown to the left of ChoiceN while under the mouse cursor; if ChoiceN='-', only the image will be shown (optional)"},
      {"ChoiceN-IMG3", "String", "URL of image to be shown to the left of ChoiceN while pressed by the mouse cursor; if ChoiceN='-', only the image will be shown (optional)"},
      {"ChoiceN-HEIGHT", "Integer", "Height of choiceN (default: parameter DefaultChoiceHeight)"},
      {"ChoiceN-FONT", "String", "Face, attributes, size of choiceN (default: parameter DefaultFont)"},
      {"Choice0-0", "String", "First choice of first submenu (optional) ('-' = no text)"},
      {"Choice0-1", "String", "Second choice of first submenu (optional) ('-' = no text)"},
      {"Choice0-N", "String", "N-th choice of first submenu (optional) ('-' = no text)"},
      {"Choice1-0", "String", "First choice of second submenu (optional) ('-' = no text)"},
      {"Choice1-1", "String", "Second choice of second submenu (optional) ('-' = no text)"},
      {"Choice1-N", "String", "N-th choice of second submenu (optional) ('-' = no text)"},
      {"ChoiceN-N-URL", "String", "URL to be opened when ChoiceN-N is clicked (optional)"},
      {"ChoiceN-N-FRAME", "String", "Destination frame to open ChoiceN-N URL (optional)"},
      {"ChoiceN-N-IMG", "String", "URL of image to be shown to the left of ChoiceN-N; if ChoiceN-N='-', only the image will be shown (optional)"},
      {"ChoiceN-N-IMG2", "String", "URL of image to be shown to the left of ChoiceN-N while under the mouse cursor; if ChoiceN-N='-', only the image will be shown (optional)"},
      {"ChoiceN-N-IMG3", "String", "URL of image to be shown to the left of ChoiceN-N while pressed by the mouse cursor; if ChoiceN-N='-', only the image will be shown (optional)"},
      {"ChoiceN-N-HEIGHT", "Integer", "Height of choiceN-N (default: parameter DefaultChoiceHeight)"},
      {"ChoiceN-N-FONT", "String", "Face, attributes, size of choiceN-N (default: parameter DefaultFont)"},
      };
    return pinfo;
  }

  // ------------------------------------------------------

  // Main method, per test
  public static void main(String[] args) {
    MenuApplet2L applet = new MenuApplet2L();
    applet.isStandalone = true;
    Frame frame = new Frame();
    frame.setTitle("Applet Frame");
    frame.add(applet, BorderLayout.CENTER);
    applet.init();
    applet.start();
    frame.setSize(150,420);
    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    frame.setLocation((d.width - frame.getSize().width) / 2, (d.height - frame.getSize().height) / 2);
    frame.setVisible(true);
  }

}
